#include "awoorwae.h"
#include <cmath>
#include <string>

namespace pabloader {

bool Awoorwae::OnUserCreate() {
    if (!player->Load()) {
        std::cerr << "Could not load awoorwa.spr" << std::endl;
        return false;
    }

    SetPixelMode(olc::Pixel::MASK);

    return true;
}

bool Awoorwae::OnUserUpdate(float fElapsedTime)
{
    Clear(olc::BLACK);

    player->Update(fElapsedTime);
    player->Draw();
    return true;
}

Entity::Entity(Awoorwae* game_, float x_, float y_)
    : game(game_)
    , x(x_)
    , y(y_)
    , xv(50)
    , yv(30)
    , color(0)
{
    xv = 10;
    yv = 10;
}

olc::rcode Entity::Load() 
{
    return img.LoadFromPGESprFile("res/awoorwa.spr");
}

void Entity::Update(float dt)
{
    x += dt * xv;
    y += dt * yv;

    if (x > game->ScreenWidth() - img.width) {
        xv *= -1.1;
        x = game->ScreenWidth() - img.width;
    }

    if (x < 0) {
        xv *= -1.1;
        x = 0;
    }

    if (y > game->ScreenHeight() - img.height) {
        yv *= -1.1;
        y = game->ScreenHeight() - img.height;
    }

    if (y < 0) {
        yv *= -1.1;
        y = 0;
    }
    color = fmodf(color + 256 * dt, 256);
}

void Entity::Draw()
{
    game->DrawSprite((int)x, (int)y, &img);
}
}