#include "olcPGEX_Graphics2D.h"
#include "olcPGEX_Sound.h"
#include "olcPixelGameEngine.h"
#include <cstdint>
#include <iostream>

namespace pabloader {
class Awoorwae;

class Entity {
private:
    Awoorwae* game;
    olc::Sprite img;
    float x;
    float y;
    float xv;
    float yv;
    float color;

public:
    Entity(Awoorwae* game_, float x_, float y_);

    void Update(float dt);
    void Draw();
    olc::rcode Load(); 
};

class Awoorwae : public olc::PixelGameEngine {
private:
    Entity* player;

public:
    Awoorwae()
    {
        sAppName = "Awoorwa";
        player = new Entity(this, 128, 128);
    }

    ~Awoorwae()
    {
        delete player;
    }

public:
    bool OnUserCreate() override;
    bool OnUserUpdate(float fElapsedTime) override;
};
}